//
//  ViewController.m
//  Plot
//
//  Created by NYU User on 12/8/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"
#import "Model.h"
#import "View.h"

@implementation ViewController

- (id) initWithNibName: (NSString *) nibNameOrNil bundle: (NSBundle *) nibBundleOrNil
{
	self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
	if (self) {
		// Custom initialization
		model = [[Model alloc] init];
	}
    return self;
}

- (void) didReceiveMemoryWarning
{
	// Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];

	// Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle


// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void) loadView
{
	CGRect frame = [UIScreen mainScreen].applicationFrame;
	self.view = [[View alloc] initWithFrame: frame viewController: self];
}


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void) viewDidLoad
{
	[super viewDidLoad];
}
*/

- (void) viewDidUnload
{
	[super viewDidUnload];
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (BOOL) shouldAutorotateToInterfaceOrientation: (UIInterfaceOrientation) interfaceOrientation
{
	// Return YES for supported orientations
	return interfaceOrientation == UIInterfaceOrientationPortrait;
}

#pragma mark -
#pragma mark methods called by methods of protocol UIPickerViewDataSource

- (NSInteger) numberOfComponentsInPickerView: (NSUInteger) pickerView
{
	return 1;
}


- (NSInteger) pickerView: (NSUInteger) pickerView numberOfRowsInComponent: (NSInteger) component
{
	return [model pickerView: pickerView numberOfRowsInComponent: component];
}

#pragma mark -
#pragma mark methods called by methods of protocol UIPickerViewDelegate

- (NSString *) pickerView: (NSUInteger) pickerView titleForRow: (NSInteger) row forComponent: (NSInteger) component
{
	NSString *string = [model pickerView: pickerView titleForRow: row forComponent: component];

	if ([string hasPrefix: @"@"]) {
		string = [string stringByReplacingOccurrencesOfString: @"@" withString: @"➔"]; //heavy arrow, Unicode \u2794
	} else {
		string = [NSString stringWithFormat: @"   %@", string];
	}
	
	return string;
}

//Allow the UIPickerView to come to rest only on a line that starts with a @.
//Go backwards to the nearest such line.

- (void) pickerView: (NSUInteger) pickerView didSelectRow: (NSInteger) row inComponent: (NSInteger) component
{
	for (; ![[model pickerView: pickerView titleForRow: row forComponent: component] hasPrefix: @"@"]; --row) {
	}

	[(View *)self.view pickerView: pickerView selectRow: row inComponent: component animated: YES];
}
@end
